extern "C" {
#include    <lwserver.h>
#include    <lwhost.h>
#include    <lwmonitor.h>
#include    <lwrender.h>
#include    <lwio.h>
#include    <lwdyna.h>
#include    <lwmaster.h>
#include <lwmodule.h>
#include <lwpanel.h>
#include <lwimage.h>
#include <lwhost.h>
#include <lwio.h>
#include <lwenvel.h>
#include <lwdisplay.h>
#include <lwdopetrack.h>
}
#include "slacking.hpp"

#include <fstream>


typedef struct st_SlackParam
{

   GlobalFunc    *global;
   char token[1024];
   char name[100];
   char channel[100];
   int sigfstart;
   int sigfend;
   int sigrend;
   std::string mytoken;
   std::string myname;
   std::string mychannel;


} SlackParam;

LWControl *CON_copyright;
LWControl *CON_token; 
LWControl *CON_name;
LWControl *CON_channel;
LWControl *CON_gettoken;
LWControl *CON_sigfstart;
LWControl *CON_sigfend;
LWControl *CON_sigrend;
GlobalFunc      *global;
LWMessageFuncs	*msg = NULL;			/* the message functions         */

LWSceneInfo		*lwsi;				/* the scene functions           */

LWPanelID		panel;				/* the panel                     */

static LWValue ival = { LWT_INTEGER }, ivecval = { LWT_VINT }, fval = { LWT_FLOAT }, fvecval = { LWT_VFLOAT }, sval = { LWT_STRING };

static LWChannelInfo *chinfo;
static LWItemInfo *iteminfo;
static LWCameraInfo *caminfo;
static LWInterfaceInfo *intinfo;
static LWDirInfoFunc *dirinfo;
static LWInstUpdate    *lwupdate = NULL;
static LWPanelFuncs   *xpanf = NULL;
static LWTimeInfo *timeinfo;

XCALL_( static const char * )Describe(SlackParam *mp);
XCALL_( static LWInstance )Create( void *userdata, void *context, LWError *err );
XCALL_( static void )Destroy(SlackParam *mp);
XCALL_( static LWError )Copy(SlackParam *to,SlackParam *from);
XCALL_( static LWError )Load(SlackParam *mp,const LWLoadState *);
XCALL_( static LWError )Save(SlackParam *mp,const LWSaveState *);
XCALL_( static double)Process(SlackParam *mp,const LWMasterAccess *);
XCALL_( static unsigned int )Flags(SlackParam *mp);
XCALL_(static int) Interface( long version, GlobalFunc *global, LWInterface *local, void *serverData );
XCALL_( int )Activate( long version, GlobalFunc *global, LWMasterHandler   *local, void *serverData );



XCALL_(LWInstance) Create( void *userdata, void *context, LWError *err )
{
   SlackParam *mp;
   char slackfile[4096];



   if ( mp = (struct st_SlackParam *)calloc( 1, sizeof( SlackParam ))) 
   {
		mp->global = ( GlobalFunc * )userdata;
		sprintf(slackfile, "%s\\slacktoken.txt", dirinfo(LWFTYPE_SETTING));

		std::ifstream infile(slackfile);
		if(infile)
		{

			std::getline(infile, mp->mytoken);
			std::getline(infile, mp->myname);
			std::getline(infile, mp->mychannel);
			infile.close();

		}
		mp->sigfend = 0;
		mp->sigfstart = 0;
		mp->sigrend = 1;
   }


    return(mp);
}

XCALL_(void) Destroy(SlackParam *mp)
{
    free(mp);
}


XCALL_(LWError) Copy(SlackParam *to,SlackParam *from)
{
    //XCALL_INIT;
   *to = *from;
    return(NULL);
}

XCALL_(LWError) Load(SlackParam *mp,const LWLoadState *lState)
{
   float f[ 3 ];
   int i;


float version;
LWLOAD_FP(lState, f, 1);
version = f[0];
LWLOAD_I4(lState, &i, 1);
mp->sigrend = (int)i;
LWLOAD_I4(lState, &i, 1);
mp->sigfstart = (int)i;
LWLOAD_I4(lState, &i, 1);
mp->sigfend = (int)i;

XCALL_INIT;




    return(NULL);
}

XCALL_(LWError) Save(SlackParam *mp,const LWSaveState *sState)
{
	float f[ 3 ];
	int i[3];
	float version;
	XCALL_INIT;

//version*
//camera*
//dopplereffect*
//soundspeed*
//streaming*
//numofsounds*
version = 0.01f;
   f[ 0 ] = version;
   LWSAVE_FP( sState, f, 1 );
   i[0] = mp->sigrend;
   LWSAVE_I4(sState,i, 1);
   i[0] = mp->sigfstart;
   LWSAVE_I4(sState, i, 1);
   i[0] = mp->sigrend;
   LWSAVE_I4(sState, i, 1);
    return(NULL);
}



XCALL_(double) Process(SlackParam *mp,const LWMasterAccess *ma)
{
	char cm[512];



//command = (char *)ma->eventData;
//commando = (int)mp->eventCode
/*
	if(ma->eventCode == LWEVNT_COMMAND )
	{
		command = (char *)ma->eventData;



		if(strcmp(command,"MakePreview")==0)
		{

		return((double)0.0);
		}
		// no audio when preview is rendered
	}*/
	if( (ma->eventCode == LWEVNT_NOTIFY_RENDER_FRAME_STARTING) && (mp->sigfstart == 1) )
	{


		if((mp->mytoken.size()>0)&& (mp->myname.size()>0)&&(mp->mychannel.size()>0))
		{
			auto& slack = slack::create(mp->mytoken); 
			slack.chat.username = mp->myname;   
			slack.chat.channel = mp->mychannel; 
			sprintf(cm, "%s\nFrame Started: %i",lwsi->filename, timeinfo->frame);
			slack.chat.postMessage(cm); 
		}


	}



	if( (ma->eventCode == LWEVNT_NOTIFY_RENDER_FRAME_COMPLETE) && (mp->sigfend == 1))
	{

		if ((mp->mytoken.size()>0) && (mp->myname.size()>0) && (mp->mychannel.size()>0))
		{
			auto& slack = slack::create(mp->mytoken);
			slack.chat.username = mp->myname;
			slack.chat.channel = mp->mychannel;
			sprintf(cm, "%s\nFrame Rendered: %i", lwsi->filename, timeinfo->frame);
			slack.chat.postMessage(cm);
		}
	}

	if( (ma->eventCode == LWEVNT_NOTIFY_RENDER_COMPLETE) && (mp->sigrend == 1))
	{

		if ((mp->mytoken.size()>0) && (mp->myname.size()>0) && (mp->mychannel.size()>0))
		{
			auto& slack = slack::create(mp->mytoken);
			slack.chat.username = mp->myname;
			slack.chat.channel = mp->mychannel;
			sprintf(cm, "%s\nRENDER COMPLETED", lwsi->filename);
			slack.chat.postMessage(cm);
		}
	}

    return((double)0.0);
}


XCALL_(unsigned int) Flags(SlackParam *mp)
{
    return(LWMASTF_RECEIVE_NOTIFICATIONS);
}

XCALL_(const char *) Describe(SlackParam *mp )
{
    return("tibe3 slack messenger");
}





XCALL_( int )Activate( long version, GlobalFunc *global, LWMasterHandler   *local, void *serverData )
{

	if ( version != LWMASTER_VERSION )
	{
		return AFUNC_BADVERSION;
	}


	
	lwsi = (struct st_LWSceneInfo *) (global)(LWSCENEINFO_GLOBAL,GFUSE_TRANSIENT );
msg = (struct st_LWMessageFuncs *)(global)( LWMESSAGEFUNCS_GLOBAL, GFUSE_TRANSIENT );
timeinfo = (struct st_LWTimeInfo *)(global)( LWTIMEINFO_GLOBAL, GFUSE_TRANSIENT );
  iteminfo = (struct st_LWItemInfo *)(global)( LWITEMINFO_GLOBAL, GFUSE_TRANSIENT );
  caminfo = (struct st_LWCameraInfo *)(global)( LWCAMERAINFO_GLOBAL, GFUSE_TRANSIENT );
intinfo = (struct st_LWInterfaceInfo *)(global)( LWINTERFACEINFO_GLOBAL, GFUSE_TRANSIENT );
  lwupdate = (void (__cdecl *)(const char *,void *))global( LWINSTUPDATE_GLOBAL, GFUSE_TRANSIENT );
  xpanf = (struct st_LWPanelFuncs *)global( LWPANELFUNCS_GLOBAL, GFUSE_TRANSIENT );
  dirinfo = (LWDirInfoFunc *)(const char *)(global)( LWDIRINFOFUNC_GLOBAL, GFUSE_TRANSIENT );

   local->inst->priv     = global;
   
   local->inst->create   = Create;
   local->inst->destroy  = (void (*)(void *))Destroy;
   local->inst->load     = (const char *(*)(void *,const struct st_LWLoadState *))Load;
   local->inst->save     = (const char *(*)(void *,const struct st_LWSaveState *))Save;
   local->inst->copy     = (const char *(__cdecl *)(void *,void *))Copy;
   local->inst->descln   = (const char *(__cdecl *)(void *))Describe;
   local->type           = LWMAST_SCENE;
   local->event       = (double (__cdecl *)(void *,const struct st_LWMasterAccess *))Process;
   local->flags          = (unsigned int (__cdecl *)(void *))Flags;




	return AFUNC_OK;
}

void launchbrowser()
{
	ShellExecute(NULL, "open", "https://api.slack.com/custom-integrations/legacy-tokens",NULL, NULL, SW_SHOWNORMAL);
}



XCALL_(static)LWXPanelID get_xpanel( GlobalFunc *global, SlackParam *mp )
{
    //XCALL_INIT;
	char buf[1024];


   static char *label[] = { "(c)2017 by tischbein3 (www.splotchdog.com)", NULL };


   LWPanelID panel = NULL;



   LWPanControlDesc desc;


  // panel = (struct st_LWPanelFuncs *)global( LWPANELFUNCS_GLOBAL, GFUSE_TRANSIENT );
   panel = PAN_CREATE( xpanf, "tibe3 slack messenger" );
   if ( !panel ) return NULL;


   CON_token = STR_CTL(xpanf, panel, "Token", 100);
   CON_gettoken = BUTTON_CTL(xpanf, panel, "Get Token");
   CON_name = STR_CTL(xpanf, panel, "Name", 50);
   CON_channel = STR_CTL(xpanf, panel, "Channel", 50);
   CON_copyright = TEXT_CTL(xpanf, panel, "", (const char **)label);
   CON_sigrend = BOOL_CTL(xpanf, panel,		"Message when render completes   ");
   CON_sigfstart = BOOL_CTL(xpanf, panel,	"Message when a new frame renders");
   CON_sigfend = BOOL_CTL(xpanf, panel,		"Message when a frame is complete ");

   sprintf(buf, "%s", mp->mytoken.c_str());
   SET_STR(CON_token, buf, sizeof(buf));
   CON_SETEVENT(CON_gettoken, launchbrowser, NULL);
   sprintf(buf, "%s", mp->myname.c_str());
   SET_STR(CON_name, buf, sizeof(buf));
   sprintf(buf, "%s", mp->mychannel.c_str());
   SET_STR(CON_channel, buf, sizeof(buf));
   SET_INT(CON_sigrend, mp->sigrend);
   SET_INT(CON_sigfstart, mp->sigfstart);
   SET_INT(CON_sigfend, mp->sigfend);


   if (xpanf->open(panel, PANF_BLOCKING | PANF_CANCEL))
   {

	   GET_STR(CON_token, mp->token, sizeof(mp->token));
	   GET_STR(CON_name, mp->name, sizeof(mp->name));
	   GET_STR(CON_channel, mp->channel, sizeof(mp->channel));

	   GET_INT(CON_sigrend, mp->sigrend);
	   GET_INT(CON_sigfstart, mp->sigfstart);
	   GET_INT(CON_sigfend, mp->sigfend);

	   char slackfile[1024];
	   sprintf(slackfile, "%s\\slacktoken.txt", dirinfo(LWFTYPE_SETTING));

	   std::ofstream infile(slackfile);
	   if (infile)
	   {
		   mp->mytoken = mp->token;
		   mp->myname = mp->name;
		   mp->mychannel = mp->channel;
		   infile << mp->mytoken;
		   infile << "\n";
		   infile << mp->myname;
		   infile << "\n";
		   infile << mp->mychannel;
		   infile << "\n";
		   infile.close();

		   std::ifstream outfile(slackfile);
		   if (infile)
		   {

			   std::getline(outfile, mp->mytoken);
			   std::getline(outfile, mp->myname);
			   std::getline(outfile, mp->mychannel);
			   outfile.close();

		   }
	   }




   }


   return NULL;
}


XCALL_(static int) Interface( long version, GlobalFunc *global, LWInterface *local, void *serverData )
{
    SlackParam          *mp;
 
    //XCALL_INIT;

    mp = (struct st_SlackParam *)local->inst;

   if ( version != LWINTERFACE_VERSION )
      return AFUNC_BADVERSION;

  chinfo = (struct st_LWChannelInfo *)xpanf->globalFun( LWCHANNELINFO_GLOBAL, GFUSE_TRANSIENT );



   //local->panel = NULL;
   local->panel = get_xpanel( global, (struct st_SlackParam *)local->inst );


   local->options = NULL;
   local->command = NULL;

    return(AFUNC_OK);
}





void *Startup( void )
{
	// Zero return is error
    return( ( void * )4 );
}






void Shutdown( void *serverData )
{
}

ServerTagInfo ServerTags[] = 
{
	{ "Audio", SRVTAG_USERNAME | LANGID_USENGLISH },
	{ "master", SRVTAG_MENU },
	{ "tibe3_audio", SRVTAG_BUTTONNAME },
	{ ( const char * )NULL, 0 }
};


extern "C" {

ServerRecord ServerDesc[] = {
   { LWMASTER_HCLASS, "tibe3_slack",
	(ActivateFunc(__cdecl *))Activate },
   { LWMASTER_ICLASS, "tibe3_slack",
	(ActivateFunc(__cdecl *))Interface },
   { NULL }
};

}


ModuleDescriptor _mod_descrip =
{
    MOD_SYSSYNC,
    MOD_SYSVER,
    MOD_MACHINE,
    Startup,
    Shutdown,
    ServerDesc
};

